package DC;

import java.util.*;
import javax.swing.JOptionPane;

import cytoscape.CyNetwork;
import cytoscape.CyNode;
import cytoscape.Cytoscape;
import cytoscape.giny.CytoscapeRootGraph;
import cytoscape.view.CyNetworkView;
import giny.view.NodeView;
import java.text.DecimalFormat;

public class DegreeCentrality{
    private CyNetworkView view;
    private CytoscapeRootGraph root;
    private NodeView nodeView;
    private CyNetwork network;
    public String DCSaveData;

    public void DCcalc(){

        network = Cytoscape.getCurrentNetwork();
        view = Cytoscape.getCurrentNetworkView();
        root = Cytoscape.getRootGraph();
        DCSaveData = "";

        List nodeList = root.nodesList();
        double n = nodeList.size();
        double pMax = 0.0; //highest degree in network
        double p = 0.0; //degree of current node
        double sumDC = 0.0;
        double numDC = 0.0; //numerator of degree centrality
        double denomDC = 0.0; //denominator of degree centrality
        double Cd = 0.0; //Degree Centrality

        //Iterate through all nodes and sum degrees
        for (Iterator iter = nodeList.iterator(); iter.hasNext();) {
            CyNode Node = (CyNode) iter.next();
            p = root.getDegree(Node);
            sumDC += p;
            if(p >= pMax){
                pMax = p;
            }else{}
        }

        numDC = n*pMax-sumDC;
        denomDC = n*n-3*n+2;

        Cd = numDC/denomDC; //Calculate Degree Centrality

        DecimalFormat df = new DecimalFormat("#.####");

        JOptionPane.showMessageDialog(Cytoscape.getDesktop(), "Degree Centrality:\n" + "CD = " + df.format(Cd));

        //Save Data
        DCSaveData = "Degree Centrality: " + df.format(Cd);
        SaveData SDobj = new SaveData();
        SDobj.WriteFile(DCSaveData);
    }
}
