package DC;

import java.util.*;
import javax.swing.JOptionPane;

import cytoscape.CyNetwork;
import cytoscape.CyNode;
import cytoscape.Cytoscape;
import cytoscape.giny.CytoscapeRootGraph;
import cytoscape.view.CyNetworkView;
import giny.model.Node;
import java.text.DecimalFormat;

public class MSP{
    private CyNetwork network;
    private CyNetworkView view;
    private CytoscapeRootGraph root;
    private boolean undirected;

    public static final int WHITE = 0, GRAY = 1, BLACK = 2;
    private int[][] capacity;
    private int[] parent, color, queue;
    private int size, source, sink;
    private int[] indexArray, adjArray;
    private boolean[] visited;
    private Boolean[] inAllPaths;
    private Stack<Integer> path;
    private boolean[][] pathMatrix;
    private int run = 0;
    public static ArrayList<Boolean[]> pathMatrix2 = new ArrayList<Boolean[]>();
    public String MSPSaveData;

    // Get the selected nodes and calculate the mean shortest path
	public void result(boolean directed) {
            network = Cytoscape.getCurrentNetwork();
            view = Cytoscape.getCurrentNetworkView();
            root = Cytoscape.getRootGraph();
            undirected = true;
            indexArray = root.getNodeIndicesArray();
            MSPSaveData = "";
            double sum = 0;
            double pathCount = 0;
            double MeanSP = 0;
            String output = "";

            //Iterate through all node combinations
            for (int i = 0; i < indexArray.length; i++){
                int node1 = indexArray[i];
                for (int j = 0; j < indexArray.length; j++){
                    int node2 = indexArray[j];

                    if(node1 == node2){}
                    else {
                        int allPaths = getShortestPath(node1,node2);
                        pathCount += 1;
                        output += allPaths + " ";
                        sum += allPaths;
                    }

                }
            }
            //Avoid divide by 0 error
            if(pathCount > 0){
            MeanSP = sum/pathCount; //Calculate mean
            }else{
                MeanSP = 0;
            }
            DecimalFormat df = new DecimalFormat("#.###");
            JOptionPane.showMessageDialog(view.getComponent(),
                "The network's mean shortest path: " + df.format(MeanSP) +
                "\n\nNumber of shortest paths: " + pathCount +
                "\nSum: " + sum);

            //Save Data
            MSPSaveData = "Mean Shortest Path: " + df.format(MeanSP)
                    + "   Number of Shortest Paths: " + pathCount
                    + "   Sum: " + sum;
            SaveData SDobj = new SaveData();
            SDobj.WriteFile(MSPSaveData);
	}

        public int getShortestPath(int node1, int node2) {

            indexArray = root.getNodeIndicesArray();
            size = indexArray.length;
            String output = "";
            int colorIndex = 0;
            int shortest = 0;
            int sTemp = 0;
            int sRow = 0;
            int SLength = 0;

            parent = new int[size];
            color = new int[size];
            queue = new int[size];
            capacity = new int[size][size];
            int index = 0;
            inAllPaths = new Boolean[size];
            java.util.Arrays.fill(inAllPaths,true); // init to all true
            visited = new boolean[size];
            java.util.Arrays.fill(visited,false); // init to all false
            path = new Stack<Integer>();
            path.clear(); // init empty
            pathMatrix = new boolean[size][size];

            CyNode cynode1 = (CyNode) network.getNode(node1);
            CyNode cynode2 = (CyNode) network.getNode(node2);
            source = -1*root.getIndex(cynode2)-1;
            sink = -1*root.getIndex(cynode1)-1;

            //Build capacity[size][size] matrix
            for (int i = 0; i < size; i++){
             adjArray = network.neighborsArray(-i-1);
             for (int j = 0; j < adjArray.length; j++){
                            index = -1*adjArray[j]-1;
                                 capacity[i][index] = 1 ;//1 means connected
                }
            }
            Arrays.fill(inAllPaths,true); // init to all true
            Arrays.fill(visited,false); // init to all false
            path.clear(); // init empty

            DFS(source);

            shortest = pathMatrix2.get(0).length;
            sTemp = pathMatrix2.get(0).length;
            for(int i=0; i<pathMatrix2.size(); i++){
                Boolean[] temp = pathMatrix2.get(i);
                sTemp = 0;
                for(int j=0; j<temp.length; j++){
                    if(temp[j] == true){
                        sTemp += 1;
                    }else{}
                }
                if(sTemp < shortest){
                    shortest = sTemp;
                    sRow = i;
                }
            }

            //Print matrix for debugging
            Boolean[] temp = pathMatrix2.get(sRow);
                for(int j=0; j<temp.length; j++){
                    if(temp[j] == true){
                        colorIndex = -1*j - 1; // Makes index negative and adjusted
                        Node node = root.getNode(colorIndex); //Get node by index
                        SLength += 1;
                }else{}
                    output += " " + temp[j];
                }
            output += "\n";

            pathMatrix2.clear();
            SLength = SLength-1;

            return SLength;
        }

        //Depth First Search
        private boolean DFS(int u){
            if (visited[u] == true){
                return true;
            }
                if (u == sink){
                    for (int i = 0; i < size; i++){
                         inAllPaths[i] = true;
                    }
                    for (int i = 0; i < size; i++){
                        if (!path.contains(i)){
                            inAllPaths[i] = false; // inAllPaths contains true only at vertices that exist in all paths from source to sink.
                            }
                    }
                    inAllPaths[sink] = true;
                    pathMatrix2.add(deepCopy(inAllPaths));
                    return true;
                 }else {
                    visited[u] = true;
                    path.push(u);
                    //foreach edge (u, v)
                    for (int k = 0; k < size; k++){
                        int v = capacity[u][k];
                        if (v != 0 && visited[k] != true){
                            DFS(k);
                        }
                    }
                    path.pop();
                    visited[u] = false;
                    return false;
                                }
                            }
        static Boolean[] deepCopy(Boolean[] orig) {
        Boolean[] copy = new Boolean[orig.length];
            copy = orig.clone();
        return copy;
    }
}
