package DC;

import java.util.*;
import javax.swing.JOptionPane;

import cytoscape.CyNetwork;
import cytoscape.CyNode;
import cytoscape.Cytoscape;
import cytoscape.giny.CytoscapeRootGraph;
import cytoscape.view.CyNetworkView;
import giny.model.Node;
import giny.view.NodeView;
import java.text.DecimalFormat;

public class TopCoef {
    private CyNetworkView view;
    private CytoscapeRootGraph root;
    private NodeView nodeView;
    private CyNetwork network;
    public String TCSaveData;

    public void TCcalc(){

        network = Cytoscape.getCurrentNetwork();
        view = Cytoscape.getCurrentNetworkView();
        root = Cytoscape.getRootGraph();
        TCSaveData = "";

        int Tt = 0; //topological total
        int counter = 0;
        double Tav = 0; //average topological coefficient
        double T = 0; //topological coefficient of nodeN
        String NodeID = "";

        //Get selected node
        //Node NodeN = nodeView.getNode(); //Get nodeN (selected by user)

        //int NIndex = root.getIndex(NodeN);
        int[] NodeN = view.getSelectedNodeIndices();
        int NIndex = NodeN[0];
        int[] neighborArrayN  = network.neighborsArray(NIndex); //Get neighbors of N
        int kn = neighborArrayN.length; //number of neighbors of nodeN
        int[] indexArray = root.getNodeIndicesArray();
        List nodeList = root.nodesList();
        int NI = 0;
        int MI = 0;

        if (kn <= 1){
            T = 0;
        }
        else{
            for (Iterator iter = nodeList.iterator(); iter.hasNext();) {
                CyNode NodeM = (CyNode) iter.next();
                int MIndex = root.getIndex(NodeM);
                int[] neighborArrayM  = network.neighborsArray(MIndex); //Get neighbors of M

                if (MIndex != NIndex){

                    //For every node contained in neighborArrayN && neighborArrayM {
                    //Add 1 to Tt & add 1 to counter }
                    for(int i=0; i<neighborArrayN.length; i++){
                        NI = neighborArrayN[i];
                        for(int j=0; j<neighborArrayM.length; j++){
                            MI = neighborArrayM[j];
                            if(MI == NI){
                                Tt += 1;
                                counter += 1;
                            }
                            //If nodeM is contained in neighborArrayN {
                            //Add 1 to Tt }
                            if(MIndex == neighborArrayN[i]){
                                Tt += 1;
                        }
                        }

                    }
                }
                else{}
        }
        }
        if(counter != 0){
        Tav = Tt / counter;
        T = Tav/kn;
        }else{
            T = 0;
        }

        DecimalFormat df = new DecimalFormat("#.#####");

        Node node = root.getNode(NIndex);
        NodeID = node.getIdentifier();

        JOptionPane.showMessageDialog(Cytoscape.getDesktop(), "Topological Coefficient of node " + NodeID + ":\n" + df.format(T));

        //Save Data
        TCSaveData = "Topological Coefficient("+NodeID+"): " + df.format(T);
        SaveData SDobj = new SaveData();
        SDobj.WriteFile(TCSaveData);
    }
}
